Number.prototype.pad = function(size){
      if(typeof(size) !== "number"){size = 2;}
      var s = String(this);
      while (s.length < size) s = "0" + s;
      return s;
}

var SpaceInvaders = SpaceInvaders || {
    implement:function(name,implementation){
        parent = window;
        parent["SpaceInvaders"][name] = implementation ;
     }
};

// Constants

SpaceInvaders.ENEMY_OFFSET = 5 ;

SpaceInvaders.ENEMY_WIDTH = 32 ;
SpaceInvaders.ENEMY_HEIGHT = 32 ;

SpaceInvaders.GAME_OFFSET_X = SpaceInvaders.ENEMY_OFFSET + ( SpaceInvaders.ENEMY_WIDTH / 2 ) ;
SpaceInvaders.GAME_OFFSET_Y = 20 ;


SpaceInvaders.PLAYER_WIDTH = 32 ;
SpaceInvaders.PLAYER_HEIGHT = 32 ;

SpaceInvaders.ROWS = 4 ;
SpaceInvaders.COLS = 8;
SpaceInvaders.ENEMY_COUNT = SpaceInvaders.ROWS * SpaceInvaders.COLS ;

SpaceInvaders.MoveState = "none" ;

// Enemy Graphics
SpaceInvaders.Class1Enemy = "Class1" ;
SpaceInvaders.Class2Enemy = "Class2" ;
SpaceInvaders.Class3Enemy = "Class3" ;
SpaceInvaders.Class4Enemy = "Class4" ;

SpaceInvaders.playerGraphic =  new Image();
SpaceInvaders.playerGraphic.loaded = false ;
SpaceInvaders.playerGraphic.onload = function(){
		SpaceInvaders.playerGraphic.loaded = true ;
 };
 SpaceInvaders.playerGraphic.src = 'http://www.swhistlesoft.com/demo/SpaceInvaders/player.png';
 
SpaceInvaders.enemyClass1 =  new Image();
SpaceInvaders.enemyClass1.loaded = false ;
SpaceInvaders.enemyClass1.onload = function(){
	//SpaceInvaders.Log.Log ( "Enemy 1 graphics loaded" ) ;
	SpaceInvaders.enemyClass1.loaded = true ;
};
SpaceInvaders.enemyClass1.src = 'http://www.swhistlesoft.com/demo/SpaceInvaders/enemy1.png';
 
SpaceInvaders.enemyClass2 =  new Image();
SpaceInvaders.enemyClass2.loaded = false ;
SpaceInvaders.enemyClass2.onload = function(){
//	SpaceInvaders.Log.Log ( "Enemy 2 graphics loaded" ) ;
	SpaceInvaders.enemyClass2.loaded = true ;
};
SpaceInvaders.enemyClass2.src = 'http://www.swhistlesoft.com/demo/SpaceInvaders/enemy2.png';

SpaceInvaders.enemyClass3 =  new Image();
SpaceInvaders.enemyClass3.loaded = false ;
SpaceInvaders.enemyClass3.onload = function(){
	//SpaceInvaders.Log.Log ( "Enemy 3 graphics loaded" ) ;
	SpaceInvaders.enemyClass3.loaded = true ;
};
SpaceInvaders.enemyClass3.src = 'http://www.swhistlesoft.com/demo/SpaceInvaders/enemy3.png';
 
SpaceInvaders.enemyClass4 =  new Image();
SpaceInvaders.enemyClass4.loaded = false ;
SpaceInvaders.enemyClass4.onload = function(){
	//SpaceInvaders.Log.Log ( "Enemy 4 graphics loaded" ) ;
	SpaceInvaders.enemyClass4.loaded = true ;
};
SpaceInvaders.enemyClass4.src = 'http://www.swhistlesoft.com/demo/SpaceInvaders/enemy4.png';

SpaceInvaders.bGameOver = false ;

Function.prototype.attach = function (name, func) {
    this.prototype[name] = func;
    return this;
};

SpaceInvaders.implement("loader",new function(){
        var loadfuncs = [];
        var oldonload = window.onload ;
        var alreadyrunflag=0 //flag to indicate whether target function has already been run
        if (document.addEventListener){
            document.addEventListener("DOMContentLoaded", function(){alreadyrunflag=1; SpaceInvaders.loader.exec();}, false)
        }else if (document.all && !window.opera){
            document.write('<script type="text/javascript" id="contentloadtag" defer="defer" src="javascript:void(0)"><\/script>')
            var contentloadtag=document.getElementById("contentloadtag")
            contentloadtag.onreadystatechange=function(){
                if (this.readyState=="complete"){
                    alreadyrunflag=1
                    SpaceInvaders.loader.exec();
                }
            }
        }
        window.onload=function(){
            setTimeout(function(){if (!alreadyrunflag){SpaceInvaders.loader.exec();}}, 0);
            if ( typeof ( oldonload ) == "function" ){
                oldonload();
            }
        };
        return{
            exec:function(){
                for ( i = 0 ; i < loadfuncs.length ; i++ ){
                    loadfuncs[i]();
                }
                return true ;
            },
            add :function(fnc){
                loadfuncs.push(fnc);
                return true ;
            }
        }
});

SpaceInvaders.implement ( "internalLog", function(){
	this.Log = function ( msg ){
		if ( typeof ( console.log ) != "undefined" ){
			console.log ( msg ) ;
		}
		return false ;
	}
});

SpaceInvaders.implement("Log", new SpaceInvaders.internalLog());

SpaceInvaders.implement ( "Drawable",function(){
	this.Font = "Verdana" ;
	this.Position = new SpaceInvaders.Point(0,0);
	this.oldPosition = new SpaceInvaders.Point(0,0);
	this.saveImage = null ;
    var iwidth = 0;
	var iheight = 0;
	this.Width = function(width){
		if ( width ){
			iwidth = width ;
		}
		return iwidth ;
	}
	this.Height = function(height){
		if ( height ){
			iheight = height ;
		}
		return iheight ;
	}
    /*this.Draw = function(graphics){
		if( graphics ){
			graphics.DrawRactangle(this.Position.X, this.Position.Y, this.Width, this.Height);
		}
	}*/
    this.Update = function(){
		SpaceInvaders.Log.Log ( "Drawable Update" ) ;
	}
	this.Collision = function(){
		SpaceInvaders.Log.Log ( "Drawable Collision" ) ;
	}
});


SpaceInvaders.implement('inherits',  function (object, parent) {
	if ( typeof ( object ) == "undefined" || typeof ( parent ) == "undefined" ){
		return ;
	}
	
	var save = {} ;
	save.prototype = new object() ;
	object.prototype = new parent ();
	object.prototype.constructor = object ;
	object.prototype.parent = parent.prototype ;
	for ( i in  save.prototype ){
		if ( i.substr(0,1) == "_" ){
			object.prototype[i.substr(1)] = save.prototype[i]();
		}
	}
});

SpaceInvaders.implement ( "Point", function(x,y){
	var ix  = x;
	var iy = y;
	this.X = function ( x ){
		if ( x ){
			ix = x ;
		}
		return ix ;
	}
	this.Y = function ( y ){
		if ( y ){
			iy = y ;
		}
		return iy ;
	}
});

SpaceInvaders.implement ( "Vector", function(x,y){
	var ix  = x;
	var iy  = y;
	this.X = function(x){
		if ( !isNaN(x) ){
			ix = x ;
		}
		return isNaN(ix)?0:ix ;
	}
	this.Y = function(y){
		if ( !isNaN(y) ){
			iy = y ;
		}
		return isNaN(iy)?0:iy ;
	}
});

SpaceInvaders.implement ( "Range",function(left, top, right, bottom){
    var l = left;
    var t  = top;
    var r = right ;
    var b = bottom;
    this.Left = function(){ return l ; }
    this.Top = function(){ return t ; }
    this.Right = function(){ return r ; }
    this.Bottom = function(){ return b ; }
    this.InRange = function(x,y){
        if ( x < l || x > r ||  y < t || y > b  ){
            return false ;
        }
        return true ;
    }
});

SpaceInvaders.implement ( "InvaderClass", function(tclass){
	var thisclass ;
	switch ( tclass ){
		case "Class1" :
		case "Class2" :
		case "Class3" :
		case "Class4" :
			thisclass = tclass ;
		break ;
		default :
			thisclass = "Class1" ;
	}
	this.InvaderClass = function(tclass){
		if ( tclass ){
			switch ( tclass ){
				case "Class1" :
				case "Class2" :
				case "Class3" :
				case "Class4" :
					thisclass = tclass ;l
				break ;
				default :
					thisclass = "Class1" ;
			}
		}
		return thisclass ;
	}
	this.Class1Enemy = function(){
		return "Class1" ;
	}
	this.Class2Enemy = function(){
		return "Class2" ;
	}
	this.Class3Enemy = function(){
		return "Class3" ;
	}
	this.Class4Enemy = function(){
		return "Class4" ;
	}
});

SpaceInvaders.implement ( "Player", function(v){
	var vv ;
	if ( typeof ( v ) == "undefined" ){
		vv = new SpaceInvaders.Vector ( 0.0,0.0 )
		//SpaceInvaders.Log.Log ( "Created Player with Vector:" + vv.X() + "," + vv.Y());
	}else{
		vv = v ; // set to incoming vector
		//SpaceInvaders.Log.Log ( "Created Player with Vector:" + vv.X() + "," + vv.Y());
	}
	this.Vector = function(){
		return vv ;
	}
	this._Update = function(ms){
			switch ( SpaceInvaders.MoveState.toString() ){
				case "Right" :
					vv.X ( vv.X ( ) + 1.0 ) ;
					if ( vv.X ( ) > 5 ) {
						vv.X ( 5 ) ;
					}
					//SpaceInvaders.Log.Log ( this.Position.X () + "," + this.Position.Y() + "," + vv.X() + "," + vv.Y() + ":" + SpaceInvaders.MoveState.toString());
				break ;
				case "Left" :
					vv.X (vv.X ( ) -1 );
					if ( vv.X ( ) < -5 ) {
						vv.X ( -5 ) ;
					}
					//SpaceInvaders.Log.Log ( this.Position.X () + "," + this.Position.Y() + "," + vv.X() + "," + vv.Y() + ":" + SpaceInvaders.MoveState.toString());
				break ;
				default :
					if ( vv.X ( )> 0 ){
						vv.X ( vv.X ( ) -1.0 ) ;
					}else if ( vv.X ( ) < 0 ){
						vv.X ( vv.X ( ) + 1.0 ) ;
					}
				break ;
			}
			if ( typeof ( this.Position ) != "undefined" ){
				this.Position.X ( this.Position.X ( ) + vv.X ( ) ) ;
				this.Position.Y ( this.Position.Y ( ) + vv.Y ( ) ) ;
				//SpaceInvaders.Log.Log ( this.Position.X () + "," + this.Position.Y() + "," + vv.X() + "," + vv.Y() + ":" + SpaceInvaders.MoveState.toString());
			}
	}
	this._Draw = function ( graphics ){
		if ( graphics && SpaceInvaders.playerGraphic.loaded ){
			//SpaceInvaders.Log.Log ( "Draw Player at :[" + this.Position.X() + "," + this.Position.Y() + "," + this.Width()+ "," + this.Height ()+ "]" ) ;
			if ( this.oldPosition.X() == this.Position.X() && this.Position.Y ( ) == this.oldPosition.Y()){
				
			}else{
				
				if ( /*this.saveImage != null && typeof ( this.saveImage ) != "undefined" && */this.oldPosition != null ){
					//SpaceInvaders.Log.Log ( "Update Player" + typeof ( this.saveImage ) + ":" + this.oldPosition.X() + ":"+ this.oldPosition.Y()+ ":" + this.Width() + ":" + this.Height()) ;
					//graphics.putImageData(this.saveImage, this.Position.X(), this.Position.Y());
					graphics.fillStyle = "black" ;
					graphics.fillRect ( this.oldPosition.X ()-SpaceInvaders.PLAYER_WIDTH / 2, this.oldPosition.Y, this.Width(), this.Height());
				}
				//this.saveImage = graphics.getImageData(this.Position.X(), this.Position.Y(),this.Width(), this.Height());
				graphics.drawImage ( SpaceInvaders.playerGraphic, this.Position.X()-SpaceInvaders.PLAYER_WIDTH / 2, this.Position.Y() ) ;
				this.oldPosition.X(this.Position.X());
				this.oldPosition.Y(this.Position.Y());
				//SpaceInvaders.Log.Log ( "Current Player" + typeof ( this.saveImage ) + ":" + this.Position.X() + ":" + this.Position.Y() + ":" + this.oldPosition.X() + ":"+ this.oldPosition.Y() + ":" + this.Width() + ":" + this.Height()) ;
				
			}
		}else{
			//SpaceInvaders.Log.Log ( "Graphics is not defined in PLayer" ) ;
		}
	}
	this.Collision = function( width, height ){
		if ( ( this.Position.X ( ) + ( this.Width ( ) / 2 ) ) > ( width - SpaceInvaders.GAME_OFFSET_X ) ){
			return true ;
		}else if ( ( this.Position.X - ( this.Width ( ) / 2 ) ) < ( SpaceInvader.GAME_OFFSET_X ) ){
			return true ;
		}
		return false ;
	}
});

SpaceInvaders.implement ( "PlayerMissle", function(v){
	var vv ;
	if ( typeof ( v ) == "undefined" ){
		vv = new SpaceInvaders.Vector ( 0.0,-5.0 )
		//SpaceInvaders.Log.Log ( "Created Player Missle with Vector:" + vv.X() + "," + vv.Y());
	}else{
		vv = v ; // set to incoming vector
		//SpaceInvaders.Log.Log ( "Created Player with Missle Vector:" + vv.X() + "," + vv.Y());
	}
	this.Vector = function(){
		return vv ;
	}
	this._Update = function(ms){
		if ( typeof ( this.Position ) != "undefined" ) {
			this.Position.X ( this.Position.X ( ) + vv.X ( ) ) ;
			this.Position.Y ( this.Position.Y ( ) + vv.Y ( ) ) ;
		}
	}
	this.Erase = function ( graphics ){
		if ( graphics ){
			if ( this.oldPosition != null ){
				graphics.strokeStyle="none";
				graphics.fillStyle = "black" ;
				graphics.lineWidth=0;
				graphics.fillRect (  this.oldPosition.X() - ( this.Width () / 2 ) -1 , this.oldPosition.Y() - ( this.Height () / 2 ) -1  , this.Width()+2, this.Height()+2);
			}
		}
	}
	this._Draw = function ( graphics ){
		if ( graphics  ){
			
			//SpaceInvaders.Log.Log ( "Draw Player Missle at :[" + this.Position.X() + "," + this.Position.Y() + "," + this.Width()+ "," + this.Height ()+ "]" ) ;
			graphics.fillStyle = "#FFFFFF" ;
			
			
			if ( this.oldPosition.X() == this.Position.X() && this.Position.Y ( ) == this.oldPosition.Y()){
				
			}else{
				
				if ( /*this.saveImage != null && typeof ( this.saveImage ) != "undefined" && */this.oldPosition != null ){
					//SpaceInvaders.Log.Log ( "Update Player" + typeof ( this.saveImage ) + ":" + this.oldPosition.X() + ":"+ this.oldPosition.Y()+ ":" + this.Width() + ":" + this.Height()) ;
					//graphics.putImageData(this.saveImage, this.Position.X(), this.Position.Y());
					graphics.strokeStyle="none";
					graphics.fillStyle = "black" ;
					graphics.lineWidth=0;
					graphics.fillRect ( this.oldPosition.X ()- ( this.Width () / 2 ) -1, this.oldPosition.Y() - ( this.Height () / 2 )-1, this.Width()+2, this.Height()+2);
				}
				//this.saveImage = graphics.getImageData(this.Position.X(), this.Position.Y(),this.Width(), this.Height());
				graphics.strokeStyle="none";
				graphics.lineWidth=0;
				graphics.fillStyle = "white" ;
				graphics.fillRect ( this.Position.X() - ( this.Width () / 2 ) , this.Position.Y() - ( this.Height () / 2 ) , this.Width(), this.Height() ) ;
				
				this.oldPosition.X(this.Position.X());
				this.oldPosition.Y(this.Position.Y());
				//SpaceInvaders.Log.Log ( "Current missle" + typeof ( this.saveImage ) + ":" + this.Position.X() + ":" + this.Position.Y() + ":" + this.oldPosition.X() + ":"+ this.oldPosition.Y() + ":" + this.Width() + ":" + this.Height()) ;
				
			}
			
		}else{
			//SpaceInvaders.Log.Log ( "Graphics is not defined in Player Missle" ) ;
		}
	}
	this.Collision = function(invaders, width, height){
		if ( this.Position.Y() < SpaceInvaders.GAME_OFFSET_Y ){
			return null ;
		}
		var r = new SpaceInvaders.Range ( this.Position.X (), this.Position.Y(), this.Position.X () + this.Width(), this.Position.Y() + this.Height () ) ;
		for ( i = 0 ; i < invaders.length ; i++ ){
			if ( !invaders[i].Destroyed() ){
				var ir = new SpaceInvaders.Range ( invaders[i].Position.X (), invaders[i].Position.Y(), invaders[i].Position.X () + invaders[i].Width(), invaders[i].Position.Y() + invaders[i].Height () ) ;
				if ( this.Intersect ( r, ir ) ){
					invaders[i].Hit();
					return invaders[i] ;
				}
			}
		}
	}
	this.Intersect = function ( me, invader ){
		return ! ( me.Left() > invader.Right() ||
			me.Right () < invader.Left() ||
			me.Top() > invader.Bottom() ||
			me.Bottom ( ) < invader.Top () ) ;
	}
});

SpaceInvaders.implement ( "Invader", function(v,invclass){
	var invaderClass = invclass ;
	var bDestroyed = false ;
	this.Position = new SpaceInvaders.Vector();
	this.oldPosition = new SpaceInvaders.Vector();
	if ( !v ){
		this.vv = new SpaceInvaders.Vector ( 0.0,0.0 )
	}else{
		this.vv = v ; // set to incoming vector
	}
	if ( !invclass ){
		invaderClass = new SpaceInvaders.InvaderClass ( "Class1" ) ;
	}else{
		invaderClass = new SpaceInvaders.InvaderClass ( invclass ) ;
	}
	this.InvaderClass = function(){
		return invaderClass.InvaderClass();
	}
	this.Vector = function(){
		return this.vv ;
	}
	//SpaceInvaders.Log.Log ( "Invader Created with class: " + invaderClass.InvaderClass() + " Vector:" + vv.X( ) + "," + vv.Y () + " and position:" + this.Position.X() + "," + this.Position.Y() );
	this.Destroyed = function (){
		return bDestroyed ;
	}
	this._Update = function (){
		if ( typeof ( this.Position ) != "undefined" ) {
			//SpaceInvaders.Log.Log ( "Position: " + this.Position.X() + "," + this.Position.Y() +" Vector X:" + this.vv.X ( )  + ", Vector Y:" + this.vv.Y ( )  ) ;
			this.Position.X ( this.Position.X ( ) + this.vv.X ( ) ) ;
			this.Position.Y ( this.Position.Y ( ) + this.vv.Y ( ) ) ;
		}
			//SpaceInvaders.Log.Log ( "Update Called with class: " + invaderClass.InvaderClass() + " Vector:" + vv.X( ) + "," + vv.Y () + " and position:" + this.Position.X() + "," + this.Position.Y() );
	}
	this.Erase = function( graphics ){
		if ( graphics ){
			if ( this.oldPosition != null ){
				graphics.strokeStyle="none";
				graphics.fillStyle = "black" ;
				graphics.lineWidth=0;
				graphics.fillRect ( this.oldPosition.X ()- ( this.Width () / 2 ) -1, this.oldPosition.Y() , this.Width()+2, this.Height()+2);
			}
		}
	}
	this._Draw = function(graphics){
		if ( graphics ){
			//SpaceInvaders.Log.Log ( "Space Invaders Draw at:[" + this.Position.X () + "," + this.Position.Y() + "," + this.Width ()+ "," + this.Height ()+ "]" ) ;
			switch ( invaderClass.InvaderClass() ){
				case invaderClass.Class1Enemy():
					if ( SpaceInvaders.enemyClass1.loaded ){
						//SpaceInvaders.Log.Log ( "Drawing Enemy type 1" ) ;
						if ( this.oldPosition != null ){
							graphics.strokeStyle="none";
							graphics.fillStyle = "black" ;
							graphics.lineWidth=0;
							graphics.fillRect ( this.oldPosition.X ()- ( this.Width () / 2 ) -1, this.oldPosition.Y() , this.Width()+2, this.Height()+2);
						}
						graphics.strokeStyle="none";
						graphics.lineWidth=0;
						graphics.fillStyle = "white" ;
						graphics.drawImage (SpaceInvaders.enemyClass1, this.Position.X() - ( this.Width() / 2 ), this.Position.Y() );
						this.oldPosition.X(this.Position.X());
						this.oldPosition.Y(this.Position.Y());
					}else{
						//SpaceInvaders.Log.Log ( "Enemy Class 1 not loaded" ) ;
					}
				break ;
				case invaderClass.Class2Enemy():
					if ( SpaceInvaders.enemyClass2.loaded ){
						//SpaceInvaders.Log.Log ( "Drawing Enemy type 2" ) ;
						if ( this.oldPosition != null ){
							graphics.strokeStyle="none";
							graphics.fillStyle = "black" ;
							graphics.lineWidth=0;
							graphics.fillRect ( this.oldPosition.X ()- ( this.Width () / 2 ) -1, this.oldPosition.Y() , this.Width()+2, this.Height()+2);
						}
						graphics.strokeStyle="none";
						graphics.lineWidth=0;
						graphics.fillStyle = "white" ;
						graphics.drawImage (SpaceInvaders.enemyClass2, this.Position.X() - ( this.Width() / 2 ), this.Position.Y() );
						this.oldPosition.X(this.Position.X());
						this.oldPosition.Y(this.Position.Y());
					}else{
						//SpaceInvaders.Log.Log ( "Enemy Class 2 not loaded" ) ;
					}
				break ;
				case invaderClass.Class3Enemy():
					if ( SpaceInvaders.enemyClass3.loaded ){
						//SpaceInvaders.Log.Log ( "Drawing Enemy type 3" ) ;
						if ( this.oldPosition != null ){
							graphics.strokeStyle="none";
							graphics.fillStyle = "black" ;
							graphics.lineWidth=0;
							graphics.fillRect ( this.oldPosition.X ()- ( this.Width () / 2 ) -1, this.oldPosition.Y() , this.Width()+2, this.Height()+2);
						}
						graphics.strokeStyle="none";
						graphics.lineWidth=0;
						graphics.fillStyle = "white" ;
						graphics.drawImage (SpaceInvaders.enemyClass3, this.Position.X() - ( this.Width() / 2 ), this.Position.Y() );
						this.oldPosition.X(this.Position.X());
						this.oldPosition.Y(this.Position.Y());
					}else{
						//SpaceInvaders.Log.Log ( "Enemy Class 3 not loaded" ) ;
					}
				break ;
				case invaderClass.Class4Enemy():
					if ( SpaceInvaders.enemyClass4.loaded ){
						//SpaceInvaders.Log.Log ( "Drawing Enemy type 4" ) ;
						if ( this.oldPosition != null ){
							graphics.strokeStyle="none";
							graphics.fillStyle = "black" ;
							graphics.lineWidth=0;
							graphics.fillRect ( this.oldPosition.X ()- ( this.Width () / 2 ) -1, this.oldPosition.Y(), this.Width()+2, this.Height()+2);
						}
						graphics.strokeStyle="none";
						graphics.lineWidth=0;
						graphics.fillStyle = "white" ;
						graphics.drawImage (SpaceInvaders.enemyClass4, this.Position.X() - ( this.Width() / 2 ), this.Position.Y() );
						this.oldPosition.X(this.Position.X());
						this.oldPosition.Y(this.Position.Y());
					}else{
						//SpaceInvaders.Log.Log ( "Enemy Class 4 not loaded" ) ;
					}
				break ;
				default :
					SpaceInvaders.Log.Log ( "Unknown enemy class" ) ;
			}
		}else{
			SpaceInvaders.Log.Log ( "Graphics is not defined in Invader" ) ;
		}
	}
	this.Collision = function(width, height){
		if ( !bDestroyed ){
			if (( this.Position.X() + (this.Width ( )/ 2) ) > ( width - SpaceInvaders.GAME_OFFSET_X )){
				return true ;
			}else if ( ( this.Position.X() - ( this.Width ( )/ 2 ) ) < SpaceInvaders.GAME_OFFSET_X){
				return true ;
			}else if ( ( this.Position.Y ( ) - this.Height ( ) ) > ( height - SpaceInvaders.GAME_OFFSET_Y )){
				SpaceInvaders.GameOver();
				return true;
			}
			return false;
		}else{
			return false ;
		}
	}
	this.Hit = function(){
		bDestroyed = true ;
	}
});


SpaceInvaders.implement ( "GameBoard", function(){
	this._Draw = function(graphics){
		if ( graphics ){
			//SpaceInvaders.Log.Log ( "Draw GameBoard: [" + this.Position.X () + "," + this.Position.Y() + "," + this.Width() + "," + this.Height() + "]") ;
			graphics.strokeStyle="white";
			graphics.lineWidth=1;
			graphics.fillStyle = "white" ;
			graphics.strokeRect ( this.Position.X(), this.Position.Y(), this.Width(), this.Height() ) ;
		}else{
			//SpaceInvaders.Log.Log ( "Graphics is not defined in GameBoard"  + typeof(_this ) + typeof ( graphics ) ) ;
		}
	}	
});
SpaceInvaders.implement ( "ScoreBoard", function(score){
	var iscore = 0;
	this.Score = function(score){
		if ( score ){
			iscore = score ;
		}
		return iscore ;
	}
	this._Draw = function(graphics){
		if ( graphics ){
			graphics.strokeStyle="none";
			graphics.fillStyle = "black" ;
			graphics.lineWidth=0;
			graphics.fillRect ( this.Position.X () -1, this.Position.Y()- this.Height(), this.Width()+2, this.Height()+2);

			graphics.strokeStyle="white";
			graphics.lineWidth=1;
			graphics.fillStyle = "white" ;
			graphics.strokeText ( iscore.pad(4) , this.Position.X(), this.Position.Y() ) ;
		}else{
			//SpaceInvaders.Log.Log ( "Graphics is not defined in ScoreBoard" ) ;
		}
	}
	this._Update = function(){
		
	}
});

SpaceInvaders.p = null ;
SpaceInvaders.pm = null ;

SpaceInvaders.implement ( "canvas", function(id,newparticleCount){
    this.displayWidth=0;
    this.displayHeight = 0;
    var center = {X:function(){},Y:function(){}};
    var cvs = null ;
    
    
    var range ;

	var bInit = false ;
	
    var spriteSheetCanvas;
    var spriteSheetContext;
	
	this.context = null ;
	
	// game vars
	this.gb = null ;
	this.sb = null ;
	//SpaceInvaders.p = null ;
	//this.pm= null ;
	this.invaders = [];

    if ( !cvs ){
        cvs = document.getElementById(id);
        if ( cvs ){
            this.displayWidth = cvs.getAttribute("width");
            this.displayHeight = cvs.getAttribute("height");
            this.context = cvs.getContext("2d");
            this.context.fillStyle = "#000000";
            this.context.fillRect(0,0,this.displayWidth,this.displayHeight);
            center = new SpaceInvaders.Vector(this.displayWidth/2,this.displayHeight/2);
            range = new SpaceInvaders.Range (0,0,this.displayWidth,this.displayHeight);
        }
    }
	
	this.InitializeGame=function(){
		this.gb = new SpaceInvaders.GameBoard();
		this.gb.Position.X ( SpaceInvaders.GAME_OFFSET_X ) ;
		this.gb.Position.Y ( SpaceInvaders.GAME_OFFSET_Y ) ;
		this.gb.Width ( this.displayWidth - ( 2 * SpaceInvaders.GAME_OFFSET_X ) ) ;
		this.gb.Height ( this.displayHeight - ( 2 * SpaceInvaders.GAME_OFFSET_Y ) ) ;
		

		this.sb = new SpaceInvaders.ScoreBoard();
		this.sb.Score ( 0 ) ;
		this.sb.Position.X ( 20 ) ;
		this.sb.Position.Y ( 15 ) ;
		this.sb.Width ( 100 ) ;
		this.sb.Height ( 20 ) ;

		SpaceInvaders.p = new SpaceInvaders.Player();
		//SpaceInvaders.Log.Log ( ( ( this.displayWidth / 2 ) - ( SpaceInvaders.PLAYER_WIDTH / 2 )).toFixed(0) ) ;
		SpaceInvaders.p. Position.X ( ( this.displayWidth / 2 ) - ( SpaceInvaders.PLAYER_WIDTH / 2 ) ) ;
		SpaceInvaders.p. Position.Y ( ( this.displayHeight ) - ( SpaceInvaders.PLAYER_HEIGHT  + SpaceInvaders.GAME_OFFSET_Y) ) ;
		SpaceInvaders.p. Width ( SpaceInvaders.PLAYER_WIDTH ) ;
		SpaceInvaders.p. Height ( SpaceInvaders.PLAYER_HEIGHT ) ;
		
		
		var irow = 0 ;
		var icol = 0 ;
		var invClass = null ;
		
		for ( i = 0 ; i < SpaceInvaders.ENEMY_COUNT ; i++ ){
			var v = new SpaceInvaders.Vector ( 1.0, 0.0 );
			switch ( irow ){
				case 0 :
					invClass = SpaceInvaders.Class1Enemy ;
				break ;
				case 1 :
					invClass = SpaceInvaders.Class2Enemy ;
				break ;
				case 2 :
					invClass = SpaceInvaders.Class3Enemy ;
				break ;
				case 3 :
					invClass = SpaceInvaders.Class4Enemy ;
				break ;
			}
			var tmp = new SpaceInvaders.Invader ( v, invClass ) ;
			tmp.Position.X ( SpaceInvaders.GAME_OFFSET_X + ( SpaceInvaders.ENEMY_WIDTH / 2 ) + ( icol * ( SpaceInvaders.ENEMY_OFFSET + SpaceInvaders.ENEMY_WIDTH ) ) );
			tmp.Position.Y ( SpaceInvaders.GAME_OFFSET_Y + ( irow * ( SpaceInvaders.ENEMY_OFFSET + SpaceInvaders.ENEMY_HEIGHT ) ) ) ;
			tmp.Width (SpaceInvaders.ENEMY_WIDTH );
			tmp.Height ( SpaceInvaders.ENEMY_HEIGHT );
			
			this.invaders.push ( tmp ) ;
			icol ++ ;
			if ( icol == SpaceInvaders.COLS ){
				icol = 0 ;
				irow ++ ;
			}
		}
		bInit = true ;
	}
	
	this.InitBoard = function(){
		this.gb = new SpaceInvaders.GameBoard();
		this.gb.Position.X ( SpaceInvaders.GAME_OFFSET_X ) ;
		this.gb.Position.Y ( SpaceInvaders.GAME_OFFSET_Y ) ;
		this.gb.Width ( this.displayWidth - ( 2 * SpaceInvaders.GAME_OFFSET_X ) ) ;
		this.gb.Height ( this.displayHeight - ( 2 * SpaceInvaders.GAME_OFFSET_Y ) ) ;
		
		//SpaceInvaders.Log.Log ( "Width: " + this.displayWidth + ", Height: " + this.displayHeight ) ;

		this.sb = new SpaceInvaders.ScoreBoard();
		this.sb.Score ( 0 ) ;
		this.sb.Position.X ( 2 ) ;
		this.sb.Position.Y ( 2 ) ;

		SpaceInvaders.p = new SpaceInvaders.Player();
		SpaceInvaders.p. Position.X ( ( this.displayWidth / 2 ) - ( SpaceInvaders.PLAYER_WIDTH / 2 ) ) ;
		SpaceInvaders.p. Position.Y ( ( this.displayHeight / 2 ) - ( SpaceInvaders.PLAYER_HEIGHT / 2 ) ) ;
		SpaceInvaders.p. Width ( SpaceInvaders.PLAYER_WIDTH ) ;
		SpaceInvaders.p. Height ( SpaceInvaders.PLAYER_HEIGHT ) ;
		var irow = 0 ;
		var icol = 0 ;
		var invClass = null ;
		this.invaders = [] ;
		for ( i = 0 ; i < SpaceInvaders.ENEMY_COUNT ; i++ ){
			var v = new SpaceInvaders.Vector ( 1.0, 0.0 );
			switch ( irow ){
				case 0 :
					invClass = SpaceInvaders.Class1Enemy ;
				break ;
				case 1 :
					invClass = SpaceInvaders.Class2Enemy ;
				break ;
				case 2 :
					invClass = SpaceInvaders.Class3Enemy ;
				break ;
				case 3 :
					invClass = SpaceInvaders.Class4Enemy ;
				break ;
			}
			var tmp = new SpaceInvaders.SpaceInvader ( v, invClass ) ;
			tmp.Position.X ( SpaceInvaders.GAME_OFFSET_X + ( SpaceInvaders.ENEMY_WIDTH / 2 ) + ( icol * ( SpaceInvaders.ENEMY_OFFSET + SpaceInvaders.ENEMY_WIDTH ) ));
			tmp.Position.Y ( SpaceInvaders.GAME_OFFSET_Y + ( irow * ( SpaceInvaders.ENEMY_OFFSET + SpaceInvaders.ENEMY_HEIGHT ) ) );
			tmp.Width = SpaceInvaders.ENEMY_WIDTH ;
			tmp.Height = SpaceInvaders.ENEMY_HEIGHT ;
			
			this.invaders.push ( tmp ) ;
			icol ++ ;
			if ( icol == SpaceInvaders.COLS ){
				icol = 0 ;
				irow ++ ;
			}
		}
	}
	
    this.run=function(cnvs){
        cnvs.Update(cnvs);
		if ( !SpaceInvaders.bGameOver ){
			setTimeout(function(){cnvs.run(cnvs);}, 1000/30 );
		}
    }
    this.Center = function(){
        return center ;
    }
    this.Range = function(){
        return range ;
    }
    this.Update = function(cnvs){
        var i = 0 ;
		if ( bInit ){
			SpaceInvaders.p. _Update.call ( SpaceInvaders.p, SpaceInvaders.MoveState) ;
			if ( SpaceInvaders.p. Collision, this.displayWidth, this.displayHeight ) {
				if ( SpaceInvaders.p. Position.X () + ( SpaceInvaders.PLAYER_WIDTH / 2 ) > ( this.displayWidth - SpaceInvaders.GAME_OFFSET_X - ( SpaceInvaders.PLAYER_WIDTH / 2 )) ){
					//SpaceInvaders.Log.Log ( "Position X is too far right:" +   ( SpaceInvaders.p. Position.X () + ( SpaceInvaders.PLAYER_WIDTH / 2 )).toString() + "," +  ( this.displayWidth - SpaceInvaders.GAME_OFFSET_X - ( SpaceInvaders.PLAYER_WIDTH / 2 )).toString()) ;
					SpaceInvaders.p. Position.X ( this.displayWidth - SpaceInvaders.GAME_OFFSET_X - ( SpaceInvaders.PLAYER_WIDTH / 2 ) ) ;
				}else if ( SpaceInvaders.p. Position.X () - ( SpaceInvaders.PLAYER_WIDTH / 2 ) < SpaceInvaders.GAME_OFFSET_X ){
					SpaceInvaders.p. Position.X ( SpaceInvaders.GAME_OFFSET_X + ( SpaceInvaders.PLAYER_WIDTH / 2 ) ) ;
				}
			}
			this.sb._Update.call(this.sb,[] );
			if ( SpaceInvaders.pm != null ){
				SpaceInvaders.pm._Update.call(SpaceInvaders.pm);
				var tmp = SpaceInvaders.pm.Collision ( this.invaders ) ;
				if ( tmp != null ) {
					tmp.Erase.call(tmp,this.context);
					SpaceInvaders.pm.Erase.call ( SpaceInvaders.pm, this.context ) ;
					switch ( tmp.InvaderClass ( ) ){
						case SpaceInvaders.Class1Enemy :
							this.sb.Score ( this.sb.Score ( )  + 10 );
						break ;
						case SpaceInvaders.Class2Enemy :
							this.sb.Score ( this.sb.Score ( )  + 15 );
						break ;
						case SpaceInvaders.Class3Enemy :
							this.sb.Score ( this.sb.Score ( )  + 20 );
						break ;
						case SpaceInvaders.Class4Enemy :
							this.sb.Score ( this.sb.Score ( )  + 25 );
						break ;
					}
					SpaceInvaders.pm = null ;
				}else{
					if ( SpaceInvaders.pm.Position.Y ( ) < SpaceInvaders.GAME_OFFSET_Y ){
						SpaceInvaders.pm = null ; // if the missle goes offscreen - then invalidate it
					}
				}
			}
			var hadCollision = false ;
			var destroyed = 0 ;
			for ( i = 0 ; i < SpaceInvaders.ENEMY_COUNT ; i ++ ){
				this.invaders[i]._Update.call(this.invaders[i],null);
				if ( !this.invaders[i].Destroyed() ){
					if ( this.invaders[i].Collision ( this.displayWidth, this.displayHeight ) ){
						//SpaceInvaders.Log.Log ( "Had Collision" ) ;
						hadCollision = true ;
					}
				}else{
					destroyed ++ ;
				}
			}
			if ( destroyed == this.invaders.length ){
				InitBoard ( ) ;
			}
			if ( hadCollision ){
				for ( i = 0 ; i < SpaceInvaders.ENEMY_COUNT ; i ++ ){
					this.invaders[i].Vector().X ( this.invaders[i].Vector().X ( ) * -1.20 );
					if ( this.invaders[i].Vector().X ( ) > 10 ){
						this.invaders[i].Vector().X ( 10 ) ;
					}
					if ( this.invaders[i].Vector().X ( ) < -10 ){
						this.invaders[i].Vector().X ( -10 ) ;
					}
					this.invaders[i].Position.Y ( this.invaders[i].Position.Y ( ) + 16 ) ;
				}
			}
			this.Paint.call(this,[]);
		}
    }
	
	this.Paint  = function(){
		var i = 0 ;
		if ( bInit ){
			//context.fillRect(0,0,displayWidth,displayHeight);
			this.gb._Draw.call ( this.gb,this.context) ;
			this.sb._Draw.call ( this.sb,this.context ) ;
			SpaceInvaders.p. _Draw.call ( SpaceInvaders.p, this.context ) ;
			if ( SpaceInvaders.pm != null ){
				SpaceInvaders.pm._Draw.call ( SpaceInvaders.pm,this.context ) ;
			}
			for ( i = 0 ; i < SpaceInvaders.ENEMY_COUNT ; i++ ){
				if ( !this.invaders[i].Destroyed() ){
					this.invaders[i]._Draw.call ( this.invaders[i], this.context ) ;
				}
			}
		}else{
			this.context.fillRect(0,0,displayWidth,displayHeight);
		}
	}
} ) ;

SpaceInvaders.GameOver = function(){
		SpaceInvaders.bGameOver = true ;
}

SpaceInvaders.KeyUp = function(e){
	e = window.event || e ;
	if ( typeof ( e.keyIdentifier ) != "undefined" ){
		switch ( e.keyIdentifier ){
			case "Left" :
				//if ( SpaceInvaders.MoveState == "Left" ) {
					SpaceInvaders.MoveState = "none" ;
				//}
			break ;
			case "Right" :
				//if ( SpaceInvaders.MoveState == "Right" ) {
					SpaceInvaders.MoveState = "none" ;
				//}
			break ;
			default :
				//SpaceInvaders.Log.Log ( "Unknown Key Up:" + e.keyIdentifier ) ;
		}
	}else{
		switch ( e.keyCode ){
			case 37 :
				SpaceInvaders.MoveState = "none" ;
			break ;
			case 39 :
				SpaceInvaders.MoveState = "none" ;
			break ;
			default :
				//SpaceInvaders.Log.Log ( "Unknown Key Down:" + e.keyCode ) ;
		}
	}
}

SpaceInvaders.KeyDown = function(e){
	e = window.event || e ;
	if ( typeof ( e.keyIdentifier ) != "undefined" ){
		switch ( e.keyIdentifier ){
			case "Left" :
				//SpaceInvaders.Log.Log ( "Move Left" ) ;
				SpaceInvaders.MoveState = "Left" ;
			break ;
			case "Right" :
				//SpaceInvaders.Log.Log ( "Move Right" ) ;
				SpaceInvaders.MoveState = "Right" ;
			break ;
			case "U+0020" :
				if ( SpaceInvaders.pm == null ){
					SpaceInvaders.pm = new SpaceInvaders.PlayerMissle();
					SpaceInvaders.pm.Position.X (SpaceInvaders.p. Position.X() ) ;
					SpaceInvaders.pm.Position.Y ( SpaceInvaders.p. Position.Y() ) ;
					SpaceInvaders.pm.Width(3 );
					SpaceInvaders.pm.Height ( 3 );
				}
			break ;
			default :
				//SpaceInvaders.Log.Log ( "Unknown Key Down:" + e.keyIdentifier ) ;
		}
	}else{
		switch ( e.keyCode ){
			case 37 :
				//SpaceInvaders.Log.Log ( "Move Left" ) ;
				SpaceInvaders.MoveState = "Left" ;
			break ;
			case 39 :
				//SpaceInvaders.Log.Log ( "Move Right" ) ;
				SpaceInvaders.MoveState = "Right" ;
			break ;
			case 32 :
				if ( SpaceInvaders.pm == null ){
					SpaceInvaders.pm = new SpaceInvaders.PlayerMissle();
					SpaceInvaders.pm.Position.X (SpaceInvaders.p. Position.X() ) ;
					SpaceInvaders.pm.Position.Y ( SpaceInvaders.p. Position.Y() ) ;
					SpaceInvaders.pm.Width(3 );
					SpaceInvaders.pm.Height ( 3 );
				}
			break ;
			default :
				//SpaceInvaders.Log.Log ( "Unknown Key Down:" + e.keyCode ) ;
		}
	}
}

SpaceInvaders.SetupHandlers = function(){
		document.onkeyup = SpaceInvaders.KeyUp ;
		document.onkeydown = SpaceInvaders.KeyDown ;
}



// Inherit Drawable
SpaceInvaders.inherits ( SpaceInvaders.GameBoard, SpaceInvaders.Drawable ) ;
SpaceInvaders.inherits ( SpaceInvaders.ScoreBoard, SpaceInvaders.Drawable ) ;
SpaceInvaders.inherits ( SpaceInvaders.Invader, SpaceInvaders.Drawable ) ;
SpaceInvaders.inherits ( SpaceInvaders.Player, SpaceInvaders.Drawable ) ;
SpaceInvaders.inherits ( SpaceInvaders.PlayerMissle, SpaceInvaders.Drawable ) ;

SpaceInvaders.loader.add ( function(){
	cnvs = new SpaceInvaders.canvas("canvs");
	SpaceInvaders.SetupHandlers();
	cnvs.InitializeGame();
    cnvs.run(cnvs);
});